# tclparse V2.00 from 14.March 1997                                 
# Copyright 1996/97 Stephan Weiss, Heiko Grossmann                  
#                   University of Stuttgart, Germany                
# For details see the copyright file included in the distribution.  
# This notice must not be removed from the file.                    
#                                                                   
# tk script to build configuration file for options

wm withdraw .


# Diese Prozedur filtert aus den Listen, die in Tk mit dem 'configure' Befehl
# mit Widgets erzeugt werden koennen, die Namen der fuer das Widget gueltigen
# Schalter heraus und bildet daraus eine Liste. Aus Kompatibilitaetsgruenden zu
# den entsprechenden Listen der Tcl-Befehle wird an jeden Schalternamen die Anzahl
# der erwarteten Argumente angehaengt ( bei Widgets immer 1 )
proc GenerateOptionList configureList {
    set resultList " "

    foreach subList $configureList {
	append resultList [lindex $subList 0] " " 1 " "
    }
    return $resultList
}


# Zuerst die Listen mit Schalternamen und jeweils erwarteter Argumentenanzahl
# fuer Tcl-Befehle erstellen. Diese muessen leider manuell erstellt werden.
# Das erste Element einer Zeile ist immer der Befehlsname oder ein Bezeichner
# fuer denselben. 

puts clock_format
puts " -format 1 -gmt 1 "

puts clock_scan
puts " -base 1 -gmt 1 "

puts exec
puts " -keepnewline 0 -- 0 "

puts fconfigure
puts " -blocking 1 -buffering 1 -buffersize 1 -eofchar 1 -translation 1 "

puts file_copy
puts " -force 0 -- 0 "

puts file_delete
puts " -force 0 -- 0 "

puts file_rename
puts " -force 0 -- 0 "

puts glob
puts " -nocomplain 0 -- 0 "

puts interp_create
puts " -safe 0 -- 0 "

puts lsearch
puts " -exact 0 -glob 0 -regexp 0 "

puts lsort
puts " -ascii 0 -integer 0 -real 0 -command 1 -decreasing 0 -increasing 0 "

puts regexp
puts " -nocase 0 -indices 0 -- 0 "

puts regsub
puts " -all 0 -nocase 0 -- 0 "

puts return
puts " -code 1 -errorcode 1 -errorinfo 1 "

puts socket 
puts " -myaddr 1 -myport 1 -async 0 "

puts subst
puts " -nobackslashes 0 -nocommands 0 "

puts switch
puts " -exact 0 -glob 0 -regexp 0 -- 0 "


#--------------------------------------------------------------------------------
# Das 'canvas'-Widget kann verschiedene 'items' erzeugen. Diese erhalten jedoch
# zur Laufzeit IDs zugewiesen, so das dieses Programm den Typ eines solchen
# 'items' nicht ermitteln kann. Da somit auch eine spezifische Pruefung der
# angegebenen Schalter bei einem 'item' nicht moeglich ist, wurden in der
# naechsten Liste die Namen aller 'item'-Schalter zusammengefasst.
#--------------------------------------------------------------------------------
puts canvas_item
puts " -anchor 1 -arrow 1 -arrowshape 1 -background 1 -bitmap 1 -capstyle 1 -extent 1 -fill 1 -font 1 -foreground 1 -height 1 -image 1 -joinstyle 1 -justify 1 -outline 1 -outlinestipple 1 -smooth 1 -splinesteps 1 -start 1 -stipple 1 -style 1 -tags 1 -text 1 -width 1 -window 1 "


#--------------------------------------------------------------------------------
# Die naechsten Listen fuer  Widgets koennen nicht (?) dynamisch erzeugt werden.
#--------------------------------------------------------------------------------
puts canvas_postscript
puts " -colormap 1 -colormode 1 -file 1 -fontmap 1 -height 1 -pageanchor 1 -pageheight 1 -pagewidth 1 -pagex 1 -pagey 1 -rotate 1 -width 1 -x 1 -y 1 "

puts clipboard_clear
puts " -displayof 1 "

puts clipboard_append
puts " -displayof 1 -format 1 -type 1 -- 0 "

puts grid
puts " -column 1 -columnspan 1 -in 1 -ipadx 1 -ipady 1 -padx 1 -pady 1 -row 1 -rowspan 1 -sticky 1 "

puts grid_columnconfigure
puts " -minsize 1 -weight 1 -pad -1 "

puts grid_rowconfigure
puts " -minsize 1 -weight 1 -pad -1 "

puts grid_slaves
puts " -row 1 -column 1 "

puts image_photo_copy
puts " -from 4 -to 4 -zoom 2 -shrink 1 -subsample 2 "

puts image_photo_put
puts " -to 4 "

puts image_photo_read
puts " -format 1 -from 4 -shrink 1 -to 4 "

puts image_photo_write
puts " -format 1 -from 4 "

puts menu_add
puts " -activebackground 1 -activeforeground 1 -accelerator 1 -background 1 -bitmap 1 -command 1 -font 1 -foreground 1 -image 1 -indicatoron 1 -label 1 -menu 1 -onvalue 1 -selectimage 1 -state 1 -underline 1 -value 1 -variable 1 "

puts pack
puts " -after 1 -anchor 1 -before 1 -expand 1 -fill 1 -in 1 -ipadx 1 -ipady 1 -padx 1 -pady 1 -side 1 "

puts place
puts " -in 1 -x 1 -relx 1 -y 1 -rely 1 -anchor 1 -width 1 -relwidth 1 -height 1 -relheight 1 -bordermode 1 "

puts selection_clear
puts " -displayof 1 -selection 1 "

puts selection_get
puts " -displayof 1 -selection 1 -type 1 "

puts selection_handle
puts " -selection 1 -type 1 -format 1 "

puts selection_own
puts " -displayof 1 -selection 1 -command 1 "

puts send
puts " -async 0 -displayof 1 -- 0 "

puts text_dump
puts " -all 0 -command 1 -mark 0 -tag 0 -text 0 -window 0 "

puts text_search
puts " -forwards 0 -backwards 0 -exact 0 -regexp 0 -nocase 0 -count 1 -- 0 "


# Im folgenden werden fuer die verschiedenen Widgets die Listen erzeugt und 
# auf stdout geschrieben.

button .a
puts button
puts [GenerateOptionList [.a configure]]
destroy .a

canvas .a
puts canvas
puts [GenerateOptionList [.a configure]]

set tag [.a create arc 0 0 0 0]
puts canvas_arc
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create bitmap 0 0]
puts canvas_bitmap
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create image 0 0]
puts canvas_image
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create line 0 0 0 0]
puts canvas_line
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create oval 0 0 0 0]
puts canvas_oval
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create polygon 0 0 0 0 0 0]
puts canvas_polygon
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create rectangle 0 0 0 0]
puts canvas_rectangle
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create text 0 0]
puts canvas_text
puts [GenerateOptionList [.a itemconfigure $tag]]

set tag [.a create window 0 0]
puts canvas_window
puts [GenerateOptionList [.a itemconfigure $tag]]
destroy .a
    
checkbutton .a
puts checkbutton
puts [GenerateOptionList [.a configure]]
destroy .a

entry .a
puts entry
puts [GenerateOptionList [.a configure]]
destroy .a

frame .a
puts frame
puts [GenerateOptionList [.a configure]]
destroy .a

image create bitmap b
puts image_bitmap
puts [GenerateOptionList [b configure]]
image delete b

image create photo p
puts image_photo
puts [GenerateOptionList [p configure]]
image delete p

label .a
puts label
puts [GenerateOptionList [.a configure]]
destroy .a

listbox .a
puts listbox
puts [GenerateOptionList [.a configure]]
destroy .a

menu .a
puts menu
puts [GenerateOptionList [.a configure]]
destroy .a

menubutton .a
puts menubutton
puts [GenerateOptionList [.a configure]]
destroy .a

message .a
puts message
puts [GenerateOptionList [.a configure]]
destroy .a

radiobutton .a
puts radiobutton
puts [GenerateOptionList [.a configure]]
destroy .a

scale .a
puts scale
puts [GenerateOptionList [.a configure]]
destroy .a

scrollbar .a
puts scrollbar
puts [GenerateOptionList [.a configure]]
destroy .a

text .a
puts text
puts [GenerateOptionList [.a configure]]

.a tag add dummyTag end
puts text_tag
puts [GenerateOptionList [.a configure]]

.a window create 0.0
puts text_window
puts [GenerateOptionList [.a configure]]
destroy .a

toplevel .a
puts toplevel
puts [GenerateOptionList [.a configure]]
destroy .a

exit
